
/*
* Print a message to stderr, add a newline,  and  do  a  fflush.   [jc
* 89/12/6]  This  is like Vdmsg, but no initial stuff is added.  It is
* normally invoked conditionally via the V?() macros.  Note that  this
* is  much  like  the  other  V_? routines, but we write to stderr
* rather than to Vout. Perhaps we should also have a similar routine
* that goes to stdout.
*/
#include "V.h"
#include "sys_varargs.h"
	extern int dbn_write;

/*VARARGS1*/
#if USE_varargs
Vvmsg(l,fmt,va_alist)
	int  l;
	char*fmt;
	va_dcl
{	va_list argp;
	int r=0, savlvl;
#else /* !USE_varargs */
Vvmsg(l,fmt,ARGLIST)
	int  l;
	char*fmt;
	long ARGLIST;
{	int r=0, savlvl;
#endif /* USE_varargs */
#if defined(USE_pthreads) && (USE_pthreads > 0)
	if (V_locking && use_pthreads) {
		pthread_lock_global_np();

	}
#endif /*USE_pthreads*/
	savlvl = Vlvl;
	Vlvl = 0;		/* Discourage debugging the debug messages! */
	if (stderr == 0) return r;

	if (!stdiofl && Fileno(stderr)<3) return r;
#if USE_varargs
    va_start(argp);
    vfprintf(stderr,fmt,argp);
    va_end(argp);
	fputc('\n',stderr);
#else /* !USE_varargs */
	fprintf(stderr,fmt,ARGLIST);
	fputc('\n',stderr);
#endif /* USE_varargs */
	fflush(stderr);
#ifndef USE_syscall	/* If defined, write() does the increment */
	++dbn_write;
#endif
	Vlvl = savlvl;
#if defined(USE_pthreads) && (USE_pthreads > 0)
	if (V_locking && use_pthreads) {

		pthread_unlock_global_np();
	}
#endif /*USE_pthreads*/
	return r;
}
