:i	static char str_dupscm_sccs_id[] = "%W% %G%";
#include "V_M_UC.h"
#include "str.h"
#include "mem.h"

/*
* Make a string structure from a null-terminated string.  Note that we may  be
* passed  the  length  as  an arg, or the caller may pass -1 for len, in which
* case we call strlen to get the length. If the caller knows the length, it is
* of  course more efficient to pass it to us than to re-compute it here.  Note
* that this routine doesn't have the obscure memory leak of  str_dupssm().  On
* the  other  hand,  if  it  can't  get space for the value, it returns a null
* string; the caller may not be expecting that.  Note also that it makes sense
* to  call  this  routine  with  src  null  and len > 0; the effect will be to
* allocate the space for an initially-null string that can grow to len bytes.
*/
Str * str_dupscm(dst,src,len,msg)
	Str *dst;		/* Output string */
	char*src;		/* Input string */
	int  len;		/* Length of src string, or -1 for strlen(src) */
	char*msg;		/* For error messages */
{	int  i, n;

:f	Fenter("str_dupscm");
	if (!msg) msg = (CP)unknown;
:6	V6M "sizeof(Str)=%d MEMALIGN=%d",sizeof(Str),MEMALIGN(sizeof(Str),MEMU) D;
	if (!dst) {			/* If there's no dst, alloc one */
		if (!(dst = (Str*)GetChunk(sizeof(Str),msg)))
			Fail;
:6		V8M "Got new Str %08X",dst D;
/*		dst->l = dst->m = 0; ** No longer needed; GetChunk does it */
/*		dst->p = dst->v = 0; */
:6		V8M "dst: l=%d m=%d v=%06X=%s",
:6			dst->l,dst->m,dst->v,Dsps(dst->v,dst->l) D;
	}
	if (src) {				/* Is src nonnull? */
		if (len < 0) {		/* Shall we determine its length? */
			len = strlen(src);
:6			V8M "Got length = %d.",len D;
		}
	}
	if (len < 0) len = -1;	/* The caller really wants a null string */
	n = len + 1;			/* Min size needed, including terminator */
	i = MEMUNIT(n);			/* Amount of space to grab */
	if (Igt(i,dst->m)) {	/* Is there room in current value? */
		if (dst->m)			/* No - Was the value allocated? */
			IRelChunk(dst->v,msg);	/* If so, free it */
:6		V6M "i=%d MEMALIGN=%d",i,MEMALIGN(i,MEMU) D;
		if (!(dst->v = (CP)GetChunk(i,msg)))
			Fail;			/* Try to get space for the new value */
/*		dst->p = dst->v;	** Leave p null now */
:6		V8M str_needmsg,i,msg,len D;
		dst->m = i;			/* Note the allocated size */
	}
	if (src && len>0) {		/* Is src nonnull? */
:6		V8M "Copy %d bytes for %s.",len,msg D;
		bcopy(src,dst->v,len);	/* Copy the data */
:1		dst->v[dst->l = len] = 0;	/* Null terminator for debugging */
:6		V8M "dst: l=%d m=%d v=%06X=%s [after bcopy]",
:6			dst->l,dst->m,dst->v,Dsps(dst->v,dst->l) D;
	} else {		/* The src string is null */
:5		V8M m_null D;
		dst->l = 0;	/* Generic null string */
	}
:2	if (Vlvl>2 && ChkStrM(dst,msg))
:2		V2M "### Bad dst string (hope it has been corrected)" D;
fail:
:5	V8M "dst: l=%d m=%d v=%06X=%s [done]",
:5		dst->l,dst->m,dst->v,Dsps(dst->v,dst->l) D;
:f	Fexit;
	return dst;
}
